<?php

const PLX_ROOT = '../../';
include PLX_ROOT . 'core/lib/class.plx.msg.php';
include 'lang/' . 'fr' . '.php';

session_start();

if(!isset($_SESSION['kzRating-plugin'])) {
	die;
}


# https://api.github.com/repos/chrislim2888/IP2Location-PHP-Module/releases/latest;

/*
html_url
https://github.com/chrislim2888/IP2Location-PHP-Module/releases/tag/8.3.0
https://github.com/chrislim2888/IP2Location-PHP-Module/archive/8.3.0.zip
* */
function installDb() {
	$error = '';
	if(!is_writable(__DIR__)) {
		$error = 'Unwritable ' . __DIR__;
	} else {
		# library for IP2LOCATION from Github
		$url = 'https://api.github.com/repos/' . $_SESSION['kzRating-plugin'] . '/releases/latest';
		$ch = curl_init($url);
		curl_setopt_array($ch, array(
			CURLOPT_RETURNTRANSFER	=> true,
			CURLOPT_USERAGENT		=> $_SERVER['HTTP_USER_AGENT'],
		));
		$resp = curl_exec($ch);
		if(!empty($resp)) {
			$infos = json_decode($resp, true);
			if(isset($infos['html_url'])) {
				$filename = tempnam(sys_get_temp_dir(), 'KZX');
				$f = fopen($filename, 'w');
				curl_setopt_array($ch, array(
					CURLOPT_URL					=> preg_replace('@/releases/tag/(.*)$@', '/archive/$1.zip', $infos['html_url']),
					CURLOPT_RETURNTRANSFER		=> false,
					CURLOPT_FOLLOWLOCATION		=> true,
					CURLOPT_HEADER				=> false,
					CURLOPT_USERAGENT			=> $_SERVER['HTTP_USER_AGENT'],
					CURLOPT_FILE				=> $f,
				));
				$resp = curl_exec($ch);
				fclose($f);
				if(!empty($resp)) {
					$zip = new ZipArchive;
					$res = $zip->open($filename);
					if ($res === TRUE) {
						$zip->extractTo(__DIR__ . '/');
						$oldname = $zip->getNameIndex(0);
						list($user, $repo) = explode('/', $_SESSION['kzRating-plugin']);
						$zip->close();
						rename($oldname, $repo);
						plxMsg::Info('INSTALL_PLUGIN_SUCCESS');
					} else {
						$error = 'GITHUB_ARCHIVE_ERROR';
					}
				} else {
					$error = 'GITHUB_ARCHIVE_ERROR';
				}
				unlink($filename);
			} else {
				$error = 'GITHUB_ERROR';
			}
		} else {
			$error = 'GITHUB_API_ERROR';
		}
		curl_close($ch);
	}

	if(!empty($error)) {
		plxMsg::Error($error);
	}
}

installDb();
header('Location: ' . PLX_ROOT . 'core/admin/parametres_help.php?help=plugin&page=kzRating');
