<div class="kzRating-help">
<p>This plugin displays a star bar for each article and allow visitors to rate each article by clicking on one of them.</p>
<p>To do this, simply insert the following code in the theme's templates:</p>
<pre><code>&lt;?php eval($plxShow->callHook('kzRating')); ?&gt;</code></pre>
<p>The code block is to be inserted in each part displaying an article. This is valid for all pages displaying an article like article.php or several articles like home.php, categorie.php, tags.php or archives.php.</p>
<p>All ratings are cumulative with a value between 0 and 1, regardless of the number of stars</p>
<p>Each visitor's IP address is recorded in digital base 32. It is not possible to vote more than once for an article.</p>
<p>Votes for an article are automatically closed no later than two months after the publication date of the article. This duration can be modified by changing the value of the constant <strong>POLLING_DURATION</strong> in the "kzRating.php" file of the plugin.</p>
<p>You can also change the number of stars at any time by changing the <strong>STARS_COUNT</strong> constant.</p>
<p>The plugin is functional with or without url rewriting.</p>
<p>In a standard configuration, the ratings are saved separately for each article in a file "aaaa-ll.xml" in the folder "data/configuration/plugins/kzRating". "aaaa" and "ll" correspond to the identifier of the article coded on 4 digits and the language of the site coded on 2 letters.</p>
<p>The size, colors and spacing of the stars are adjustable with CSS rulers:</p>
<pre><code>body { --kzRatingcolor1: #258fd6; } /* bleu comme thème par défaut */
.kzRating svg { fill: #ccc; }
.kzRating.open li:hover svg { fill: red; }
.kzRating {
	--size: 2rem; /* taille */
	gap: 0.5rem; /* espacement */
}</code></pre>
<p>It is possible to extract the IP addresses of each voter for an article with the following code:</p>
<pre><code>&lt;?php
$a = '30ageie';
echo long2ip(base_convert($a, 32, 10));
# affiche 192.168.58.78
?&gt;</code></pre>
It is possible to locate IP addresses by country, city and region with one of the free databases published by:<br />
<a class="trademark" href="https://lite.ip2location.com/ip2location-lite" target="_blank"><img src="<?= PLX_PLUGINS ?>kzRating/ip2location.png" alt="IP2LOCATION" /></a><br />
<p>
By default the plugin for IP2LOCATION installs a database reduced to IP addresses by country. For a more detailed location, click on the logo above and choose a more detailed database.<br />
It is necessary to create a free or paid account on this site to download a database.<br />
Then unfold the downloaded zip archive in the "databases" folder.
</p>
<p>However, be careful not to choose a database that is too detailed, which will slow down the location of an IP address.<br />
The country-limited DB1 database has 172,372 records.<br />
The DB3 database with the detail by city has 2,929,715 records.
</p>
<?php
list($author, $repo) = explode('/', kzRating::IP2LOCATION_PLUGIN_GITHUB_REPO);
if(!is_dir(PLX_PLUGINS . $page . '/' . $repo)) {
?>
<p>
	The library <a href="https://github.com/<?= kzRating::IP2LOCATION_PLUGIN_GITHUB_REPO ?>/"><?= $repo ?></a> has to be installed in the plugin folder.
</p>
<?php
	if(function_exists('curl_init')) {
		$_SESSION['kzRating-plugin'] = kzRating::IP2LOCATION_PLUGIN_GITHUB_REPO;
	?>
<p><a class="button" href="<?= PLX_PLUGINS . $page ?>/install-db.php">Install this library from Github</a></p>
	<?php
	} else {

	}
}
?>
<div>
	<p>Sites providing IP address ranges by country</p>
	<ul>
		<li><a href="https://github.com/herrbischoff/country-ip-blocks" blank="_blank">https://github.com/herrbischoff/country-ip-blocks</a></li>
		<li><a href="http://ipverse.net" blank="_blank">http://ipverse.net</a></li>
	</ul>
</div>
<?php
if(is_dir(PLX_PLUGINS . 'kzRating/IP2Location-PHP-Module')) {
	$lang = $plxAdmin->aConf['default_lang'];
?>
<p>The IP2LOCATION database is installed on this server. From this:</p>
<form action="<?= PLX_PLUGINS ?>kzRating/test/index.php" target="_blank">
	<label>
		<span>Display the IP range for this country</span>
		<select name="code">
<?= implode(PHP_EOL,array_map(
	function($item) use($lang) {
		$selected = ($item == $lang) ? ' selected' : '';
		return  '<option value="' . $item . '"' . $selected . '>' . $item . '</option>' . PHP_EOL;
	},
	array('de', 'en', 'es', 'fr', 'it', 'nl', 'pl', 'pt', 'ro', 'ru')
));
?>
		</select>
		<input type="submit" />
		<p><em>Please be patient, all records in the database will be examined.</em></p>
	</label>
</form>
<?php
}
?>
</div>
